<template>
  <div class="my-3 text-center">
    <b-button class="rounded-0 mx-1 font-weight-bold" :variant="filter === 'all'? 'dark':'light'" v-on:click="resetFilter">All products</b-button>
    <b-button class="rounded-0 mx-1 font-weight-bold" :variant="filter === cat? 'dark':'light'" v-for="cat in this.categories" :key="cat" v-on:click="filterByCat(cat)">{{ cat }}</b-button>
  </div>
</template>

<script>
import { mapFields } from 'vuex-map-fields'

export default {
  name: 'Filters',
  data: function () {
    return {
      filter: 'all'
    }
  },
  computed: {
    ...mapFields([
      'categories',
      'products',
      'filteredProducts'
    ])
  },
  methods: {
    filterByCat (categorie) {
      this.filteredProducts = this.products.filter((product) => product.category === categorie)
      this.filter = categorie
    },
    resetFilter () {
      this.filteredProducts = this.products
      this.filter = 'all'
    }
  }
}
</script>
